/*
 *
 * 2005  Met_Enkeph aka Evan Eveland, DC
 * File: deskcutSettings.js
 *       proc file for settings dialog
 */

// Ahhhhh, the joy that is a global var
// var gData;
const deskcut_pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
var gdeskcutBundle;

function deskcut_initializeOptions() {
  gdeskcutBundle = document.getElementById("dskcut_strings");
  if (! gdeskcutBundle) {
    alert("no bundle");
  }
  var pref = getDeskcutPrefs();
  // for tab1: naming stuff
  var nameScheme = pref.get("name_scheme");
  if(nameScheme == 0) {
    document.getElementById('settings-iframe1-radio1a').setAttribute('selected', true);
    document.getElementById('settings-iframe1-radio1b').setAttribute('selected', false);
    document.getElementById('settings-iframe1-radio2a').disabled = true;
    document.getElementById('settings-iframe1-radio2b').disabled = true;
  } else if(nameScheme == 1) {
    document.getElementById('settings-iframe1-radio1a').setAttribute('selected', false);
    document.getElementById('settings-iframe1-radio1b').setAttribute('selected', true);
    document.getElementById('settings-iframe1-radio2a').disabled = false;
    document.getElementById('settings-iframe1-radio2a').setAttribute('selected', true);
    document.getElementById('settings-iframe1-radio2b').setAttribute('selected', false);
    document.getElementById('settings-iframe1-radio2b').disabled = false;
  } else if (nameScheme == 2) {
    document.getElementById('settings-iframe1-radio1a').setAttribute('selected', false);
    document.getElementById('settings-iframe1-radio1b').setAttribute('selected', true);
    document.getElementById('settings-iframe1-radio2a').disabled = false;
    document.getElementById('settings-iframe1-radio2a').setAttribute('selected', false);
    document.getElementById('settings-iframe1-radio2b').disabled = false;
    document.getElementById('settings-iframe1-radio2b').setAttribute('selected', true);
  }
  
  var addDate = pref.get("add_date");
  if (addDate == true) {
    document.getElementById('settings-iframe1-ckbox1').setAttribute('checked', true);
    document.getElementById('settings-iframe1-textbox1').disabled = false;
  } else {
    document.getElementById('settings-iframe1-ckbox1').setAttribute('checked', false);
    document.getElementById('settings-iframe1-textbox1').disabled = true;
  }
  var dateFormat = pref.get("date_format");
  document.getElementById('settings-iframe1-textbox1').value = dateFormat;
  var tDate = new Date();
  var dateString = formatDate(tDate, dateFormat);
  document.getElementById('settings-iframe1-text3').setAttribute('value', dateString);

  // for tab2:
  var dirScheme = pref.get("dir_scheme");
  if (dirScheme == 0) {
    document.getElementById('settings-iframe2-radio1a').setAttribute('selected', true);
    document.getElementById('settings-iframe2-radio2a').disabled = false;
    document.getElementById('settings-iframe2-radio2a').setAttribute('selected', true);
    document.getElementById('settings-iframe2-radio2b').disabled = false;
    document.getElementById('settings-iframe2-radio2b').setAttribute('selected', false);
    document.getElementById('settings-iframe2-radio1b').setAttribute('selected', false);
    document.getElementById('settings-iframe2-button1').disabled = true;
    document.getElementById('settings-iframe2-radio1c').setAttribute('selected', false);
    document.getElementById('settings-iframe2-button2').disabled = true;
  } else if (dirScheme == 1) {
    document.getElementById('settings-iframe2-radio1a').setAttribute('selected', true);
    document.getElementById('settings-iframe2-radio2a').disabled = false;
    document.getElementById('settings-iframe2-radio2a').setAttribute('selected', false);
    document.getElementById('settings-iframe2-radio2b').disabled = false;
    document.getElementById('settings-iframe2-radio2b').setAttribute('selected', true);
    document.getElementById('settings-iframe2-radio1b').setAttribute('selected', false);
    document.getElementById('settings-iframe2-button1').disabled = true;
    document.getElementById('settings-iframe2-radio1c').setAttribute('selected', false);
    document.getElementById('settings-iframe2-button2').disabled = true;
  } else if (dirScheme == 2) {
    document.getElementById('settings-iframe2-radio1a').setAttribute('selected', false);
    document.getElementById('settings-iframe2-radio2a').disabled = true;
    //document.getElementById('settings-iframe2-radio2a').setAttribute('selected', false);
    document.getElementById('settings-iframe2-radio2b').disabled = true;
    //document.getElementById('settings-iframe2-radio2b').setAttribute('selected', false);
    document.getElementById('settings-iframe2-radio1b').setAttribute('selected', true);
    document.getElementById('settings-iframe2-button1').disabled = false;
    document.getElementById('settings-iframe2-radio1c').setAttribute('selected', false);
    document.getElementById('settings-iframe2-button2').disabled = true;
  } else if (dirScheme == 3) {
    document.getElementById('settings-iframe2-radio1a').setAttribute('selected', false);
    document.getElementById('settings-iframe2-radio2a').disabled = true;
    //document.getElementById('settings-iframe2-radio2a').setAttribute('selected', false);
    document.getElementById('settings-iframe2-radio2b').disabled = true;
    //document.getElementById('settings-iframe2-radio2b').setAttribute('selected', false);
    document.getElementById('settings-iframe2-radio1b').setAttribute('selected', false);
    document.getElementById('settings-iframe2-button1').disabled = true;
    document.getElementById('settings-iframe2-radio1c').setAttribute('selected', true);
    document.getElementById('settings-iframe2-button2').disabled = false;
  }
  var deskPath = pref.get("desk_path");
  document.getElementById('settings-iframe2-textbox1').setAttribute('value', deskPath);
  // for tab3: other
  var alertMessagebox = pref.get("alert_messagebox");
  if (alertMessagebox == true){
    document.getElementById('settings-iframe3-ckbox1').setAttribute('checked', true);
  } else {
    document.getElementById('settings-iframe3-ckbox1').setAttribute('checked', false);
  }
  var alertAudio = pref.get("alert_audio");
  if (alertAudio == true) {
    document.getElementById('settings-iframe3-ckbox2').setAttribute('checked', true);
    document.getElementById('settings-iframe3-radio1a').disabled = false;
    document.getElementById('settings-iframe3-radio1b').disabled = false;
    //  Button greying issues located by Alan Ziesik (Alan.Ziesik@tesat.de)
    document.getElementById('settings-iframe3-button1').disabled = false;
    document.getElementById('settings-iframe3-textbox1').disabled = false;
  } else {
    document.getElementById('settings-iframe3-ckbox2').setAttribute('checked', false);
    document.getElementById('settings-iframe3-radio1a').disabled = true;
    document.getElementById('settings-iframe3-radio1b').disabled = true;
    //  Button greying issues located by Alan Ziesik (Alan.Ziesik@tesat.de)
    document.getElementById('settings-iframe3-button1').disabled = true;
    document.getElementById('settings-iframe3-textbox1').disabled = true;
  }
  var alertBeep = pref.get("alert_beep");
  if (alertBeep == true) {
    document.getElementById('settings-iframe3-radio1a').setAttribute('selected', true);
    document.getElementById('settings-iframe3-button1').disabled = true;
  } else {
    document.getElementById('settings-iframe3-radio1a').setAttribute('selected', false);
    document.getElementById('settings-iframe3-button1').disabled = false;
  }
  var alertWav = pref.get("alert_wav");
  if (alertWav == true) {
    document.getElementById('settings-iframe3-radio1b').setAttribute('selected', true);
    if (alertAudio == true) {
      //  Button greying issues located by Alan Ziesik (Alan.Ziesik@tesat.de)
      document.getElementById('settings-iframe3-button1').disabled = false;
      document.getElementById('settings-iframe3-textbox1').disabled = false;
    }
  } else {
    //  Button greying issues located by Alan Ziesik (Alan.Ziesik@tesat.de)
    document.getElementById('settings-iframe3-radio1b').setAttribute('selected', false);
    document.getElementById('settings-iframe3-textbox1').disabled = true;
    document.getElementById('settings-iframe3-button1').disabled = true;
  }
  //var deskPath = pref.get("desk_path");
  //document.getElementById('settings-iframe2-textbox1').setAttribute('value', deskPath);
  var wavPath = pref.get("wav_path");
  document.getElementById('settings-iframe3-textbox1').setAttribute('value',wavPath);
  var fileOverwrite = pref.get("file_overwrite");
  if(fileOverwrite == 0) {
    document.getElementById('settings-iframe3-radio2a').setAttribute('selected', true);
    document.getElementById('settings-iframe3-radio2b').setAttribute('selected', false);
    document.getElementById('settings-iframe3-radio2c').setAttribute('selected', false);
    document.getElementById('settings-iframe3-ckbox3').disabled = true;
    document.getElementById('settings-iframe3-radio3a').disabled = true; 
    document.getElementById('settings-iframe3-radio3b').disabled = true;
  } else if(fileOverwrite == 1) {
    document.getElementById('settings-iframe3-radio2a').setAttribute('selected', false);
    document.getElementById('settings-iframe3-radio2b').setAttribute('selected', true);
    document.getElementById('settings-iframe3-radio2c').setAttribute('selected', false);
    document.getElementById('settings-iframe3-ckbox3').disabled = false;
  } else if(fileOverwrite == 2) {
    document.getElementById('settings-iframe3-radio2a').setAttribute('selected', false);
    document.getElementById('settings-iframe3-radio2b').setAttribute('selected', false);
    document.getElementById('settings-iframe3-radio2c').setAttribute('selected', true);
    document.getElementById('settings-iframe3-ckbox3').disabled = false;
  }
  var makeUnique = pref.get("make_unique");
  if (makeUnique == true) {
    document.getElementById('settings-iframe3-ckbox3').setAttribute('checked', true);
    document.getElementById('settings-iframe3-radio3a').disabled = false;
    document.getElementById('settings-iframe3-radio3b').disabled = false;
  } else {
    document.getElementById('settings-iframe3-ckbox3').setAttribute('checked', false);
    document.getElementById('settings-iframe3-radio3a').disabled = true;
    document.getElementById('settings-iframe3-radio3b').disabled = true;
  }
  var dupFormat = pref.get("dup_format");
  if (dupFormat == 0) {
    document.getElementById('settings-iframe3-radio3a').setAttribute('selected', true);
  } else {
    document.getElementById('settings-iframe3-radio3b').setAttribute('selected', true);
  }
}


// ---------------------------------------------- setDeskcutOptions() ----------------------------------------------
function deskcut_saveOptions() {
  // for tab1: naming stuff
  if (document.getElementById('settings-iframe1-radio1a').getAttribute('selected') == 'true') {
    deskcut_pref.setIntPref('deskcut.name_scheme', '0');
  } else if (document.getElementById('settings-iframe1-radio2a').getAttribute('selected')=='true') {
    deskcut_pref.setIntPref('deskcut.name_scheme', '1');
  } else {
    deskcut_pref.setIntPref('deskcut.name_scheme', '2');
  }
  if (document.getElementById('settings-iframe1-ckbox1').getAttribute('checked') == 'true') {
    deskcut_pref.setBoolPref('deskcut.add_date', true);
    deskcut_pref.setCharPref('deskcut.date_format',document.getElementById('settings-iframe1-textbox1').value);
  } else {
    deskcut_pref.setBoolPref('deskcut.add_date', false);
  }
  // for tab2:
  if (document.getElementById('settings-iframe2-radio1b').getAttribute('selected') == 'true') {
    deskcut_pref.setIntPref('deskcut.dir_scheme', '2');
    deskcut_pref.setCharPref('deskcut.desk_path',document.getElementById('settings-iframe2-textbox1').value);
  } else if (document.getElementById('settings-iframe2-radio1c').getAttribute('selected') == 'true') {
    deskcut_pref.setIntPref('deskcut.dir_scheme', '3');
    deskcut_pref.setCharPref('deskcut.desk_path',document.getElementById('settings-iframe2-textbox1').value);
  } else if (document.getElementById('settings-iframe2-radio2a').getAttribute('selected') == 'true') {
    deskcut_pref.setIntPref('deskcut.dir_scheme', '0');
  } else if (document.getElementById('settings-iframe2-radio2b').getAttribute('selected') == 'true') {
    deskcut_pref.setIntPref('deskcut.dir_scheme', '1');
  }
   // for tab3: other
  if (document.getElementById('settings-iframe3-ckbox1').getAttribute('checked') == 'true') {
    deskcut_pref.setBoolPref('deskcut.alert_messagebox', true);
  } else {
    deskcut_pref.setBoolPref('deskcut.alert_messagebox', false);
  }
  if (document.getElementById('settings-iframe3-ckbox2').getAttribute('checked') == 'true') {
    deskcut_pref.setBoolPref('deskcut.alert_audio', true);
    if (document.getElementById('settings-iframe3-radio1a').getAttribute('selected') == 'true') {
      deskcut_pref.setBoolPref('deskcut.alert_beep', true);
      deskcut_pref.setBoolPref('deskcut.alert_wav', false);
    }  else if (document.getElementById('settings-iframe3-radio1b').getAttribute('selected') == 'true') {
      deskcut_pref.setBoolPref('deskcut.alert_beep', false);
      deskcut_pref.setBoolPref('deskcut.alert_wav', true);
      deskcut_pref.setCharPref('deskcut.wav_path',document.getElementById('settings-iframe3-textbox1').value);
    }
  } else {
    deskcut_pref.setBoolPref('deskcut.alert_audio', false);
  }
  if (document.getElementById('settings-iframe3-radio2a').getAttribute('selected') == 'true') {
    deskcut_pref.setIntPref('deskcut.file_overwrite', '0');
  } else if (document.getElementById('settings-iframe3-radio2b').getAttribute('selected') == 'true') {
    deskcut_pref.setIntPref('deskcut.file_overwrite', '1');
  } else {
    deskcut_pref.setIntPref('deskcut.file_overwrite', '2');
  }
  if (document.getElementById('settings-iframe3-ckbox3').getAttribute('checked') == 'true') {
    deskcut_pref.setBoolPref('deskcut.make_unique', true);
    if (document.getElementById('settings-iframe3-radio3a').getAttribute('selected')) {
      deskcut_pref.setIntPref('deskcut.dup_format', '0');
    } else {
      deskcut_pref.setIntPref('deskcut.dup_format', '1');
    }
  } else {
    deskcut_pref.setBoolPref('deskcut.make_unique', false);
  }
}
   
  
// ---------------------------------------------- settings_iframe1_radio2() -----------------------------------
// dim/undim 2nd set of radio buttons and checkbox on iframe1
// should also populate settings-iframe1-text1 with the valuse that the name would get (from current page)
function settings_iframe1_radio2() {
  //alert ("settings_iframe1_radio2");
  if (document.getElementById('settings-iframe1-radio1a').getAttribute('selected')) {
    document.getElementById('settings-iframe1-radio2a').disabled = true;
    document.getElementById('settings-iframe1-radio2b').disabled = true;
  } else {
    document.getElementById('settings-iframe1-radio2a').disabled = false;
    document.getElementById('settings-iframe1-radio2b').disabled = false;
  }
  
}

// ---------------------------------------------- settings_iframe1_ckbox1() -----------------------------------
//
function settings_iframe1_ckbox1() {
  if (document.getElementById('settings-iframe1-ckbox1').getAttribute('checked') == 'true') {
    document.getElementById('settings-iframe1-textbox1').disabled = false;
    document.getElementById('settings-iframe1-text1').value = "&settings-iframe1-text1-label;"
  } else {
    document.getElementById('settings-iframe1-textbox1').disabled = true;
    document.getElementById('settings-iframe1-text1').value = "";
  }
}

// ---------------------------------------------- settings-iframe1-textbox1() -----------------------------------
//
function settings_iframe1_textbox1() {
  var dateFormat = document.getElementById('settings-iframe1-textbox1').value;
  var tDate = new Date();
  var dateString = formatDate(tDate, dateFormat);
  document.getElementById('settings-iframe1-text3').setAttribute('value', dateString);
}

// ---------------------------------------------- settings_iframe2_radio1() -----------------------------------
// dim/undim
function settings_iframe2_radio1() {
  if (document.getElementById('settings-iframe2-radio1a').getAttribute('selected') == 'true') {
    document.getElementById('settings-iframe2-radio2a').disabled = false;
    document.getElementById('settings-iframe2-radio2b').disabled = false;
    document.getElementById('settings-iframe2-button1').disabled = true;
    document.getElementById('settings-iframe2-button2').disabled = true;
  } else if (document.getElementById('settings-iframe2-radio1b').getAttribute('selected') == 'true') {
    document.getElementById('settings-iframe2-radio2a').disabled = true;
    document.getElementById('settings-iframe2-radio2b').disabled = true;
    document.getElementById('settings-iframe2-button1').disabled = false;
    document.getElementById('settings-iframe2-button2').disabled = true;
  } else if (document.getElementById('settings-iframe2-radio1c').getAttribute('selected') == 'true') {
    document.getElementById('settings-iframe2-radio2a').disabled = true;
    document.getElementById('settings-iframe2-radio2b').disabled = true;
    document.getElementById('settings-iframe2-button1').disabled = true;
    document.getElementById('settings-iframe2-button2').disabled = false;
  }
}


// ---------------------------------------------- settings_iframe2_button1() -----------------------------------
// Find Desktop and populate settings-iframe2-textbox1 with it
function settings_iframe2_button1() {
  var gOS = getOS();
  var gDesktop = "";
  if  (gOS == "win") {
    gDesktop =  getWinDesktop();
  } else if (gOS == "lin") {
    gDesktop =  getLinDesktop();
  } else if (gOS == "mac") {
  }
  document.getElementById('settings-iframe2-textbox1').value = gDesktop;
}


// ---------------------------------------------- settings_iframe2_button2() -----------------------------------
// Set path
function settings_iframe2_button2() {
  var setPath = pathPrompt("dialog_Title");
  document.getElementById('settings-iframe2-textbox1').value = setPath;
}

// ---------------------------------------------- settings_iframe3_ckbox2() -----------------------------------
//
function settings_iframe3_ckbox2() {
  if (document.getElementById('settings-iframe3-ckbox2').getAttribute('checked') == 'true') {
    document.getElementById('settings-iframe3-radio1a').disabled = false;
    //  Button greying issues located by Alan Ziesik (Alan.Ziesik@tesat.de)
    document.getElementById('settings-iframe3-radio1b').disabled = false;
    settings_iframe3_radio1();
  } else {
    document.getElementById('settings-iframe3-radio1a').disabled = true;
    document.getElementById('settings-iframe3-radio1b').disabled = true;
    document.getElementById('settings-iframe3-button1').disabled = true;
    document.getElementById('settings-iframe3-textbox1').disabled = true;
  }
}
// ---------------------------------------------- settings_iframe3_radio1() -----------------------------------
// enable/disable settings-iframe3-textbox1
function settings_iframe3_radio1() {
  if (document.getElementById('settings-iframe3-radio1a').getAttribute('selected')) {
    document.getElementById('settings-iframe3-button1').disabled = true;
    document.getElementById('settings-iframe3-textbox1').disabled = true;
  } else {
    document.getElementById('settings-iframe3-button1').disabled = false;
    document.getElementById('settings-iframe3-textbox1').disabled = false;
  }
}
// ---------------------------------------------- settings_iframe3_button1() -----------------------------------
// locate wav file to play
function settings_iframe3_button1 () {
  var wavTitle = getBundle("deskcut.wavTitle");
  var wavType = getBundle("deskcut.wavType");
  var wavPath = filePrompt (wavTitle,wavType,"*.wav");
  document.getElementById('settings-iframe3-textbox1').value = wavPath;
}
// ---------------------------------------------- settings_iframe3_radio2() -----------------------------------
// dim/undim make unique checkbox on iframe3
function settings_iframe3_radio2() {
  //alert ("settings_iframe3_radio1");
  if (document.getElementById('settings-iframe3-radio2a').getAttribute('selected')) {
    document.getElementById('settings-iframe3-ckbox3').disabled = true;
    document.getElementById('settings-iframe3-radio3a').disabled = true;
    document.getElementById('settings-iframe3-radio3b').disabled = true;
  } else {
    document.getElementById('settings-iframe3-ckbox3').disabled = false;
    settings_iframe3_ckbox3();
  }
}

function settings_iframe3_ckbox3() {
  if (document.getElementById('settings-iframe3-ckbox3').getAttribute('checked') == 'true') {
    document.getElementById('settings-iframe3-radio3a').disabled = false;
    document.getElementById('settings-iframe3-radio3b').disabled = false;
  } else {
    document.getElementById('settings-iframe3-radio3a').disabled = true;
    document.getElementById('settings-iframe3-radio3b').disabled = true;
  }
}

// ---------------------------------------------- formatDate(date,format)  -----------------------------------
// returns the date in the format specified.
// Code (with super, tiny, minor modification) from:
//   http://www.mattkruse.com/javascript/date/source.html
//   Author: Matt Kruse <matt@mattkruse.com>
//   WWW: http://www.mattkruse.com/
// Valid date formats:
// Field        |
// -------------+--------------------------------------------
// Year         | yyyy (4 digits) or YY (2 digits)
// Month        | NNNN (Full Month Name) or NNN (abbr.) or NN (2 digits) or N (1 or 2 digits)
// Day of Month | DD (2 digits) or D (1 or 2 digits)
// Day of Week  | EE (name) or E (abbr)
// Hour (1-12)  | HH (2 digits) or H (1 or 2 digits)
// Hour (1-24)  | KK (2 digits) or K (1 or 2 digits)
// Minute       | MM (2 digits) or M (1 or 2 digits)
// Second       | SS (2 digits) or S (1 or 2 digits)
// AM/PM        | A
//

// Examples (note: not case sensative):
//  "NNNN DD, yyyy hh:mm:ssa" == "January 01, 2000 12:30:45AM"
//  "NNN D, yyyy HH:M:ss" == "Jan 1, 2000 16:30:45"
//  "NN/DD/YY" == "01/01/00"
//  "NN/DD/YYYY" == "01/01/2000"
//  "E, NNN DD, YYYY" == "Tue, Jan 01,2000"
function formatDate(date,format) {
  var MONTH_NAMES=new Array('January','February','March','April','May','June','July','August','September','October','November','December');
  var MONTH_ABR=new Array('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
  var DAY_NAMES=new Array('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday');
  var DAY_ABR=new Array('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
  format=format.toUpperCase()+"";
	var retVal="";
	var formatItr = 0;
	var lChar="";
	var lToken="";
	var lYear=date.getYear()+"";
	var lMonth=date.getMonth()+1;
	var lDate=date.getDate();
	var lDay=date.getDay();
	var lHour=date.getHours();
	var lMin=date.getMinutes();
	var lSec=date.getSeconds();
	var YYYY,YY,NNNN,NNN,NN,N,DD,D,EE,E,HH,H,KK,K,MM,M,SS,S,A;
	// Convert real date parts into formatted versions
	var value=new Object();
	// verify the year is 4 chars long...
	if (lYear.length < 4) {lYear=""+(lYear-0+1900);}
  // assign the year values
	value["YYYY"]=""+lYear;
	value["YY"]=""+lYear.substring(2,4);
	// assign the month values
	value["NNNN"]=MONTH_NAMES[lMonth-1];
	value["NNN"]=MONTH_ABR[lMonth-1];
	value["NN"]=LZ(lMonth);
	value["N"]=""+lMonth;
	// assign the day values
	value["D"]=""+lDate;
	value["DD"]=LZ(lDate);
	value["E"]=DAY_ABR[lDay];
	value["EE"]=DAY_NAMES[lDay];
	// assign the hour values
  if (lHour == 0) {
    value["H"]=12;
  }	else if (lHour > 12) {
    value["H"]= lHour - 12;
  }	else {
    value["H"]=lHour;
  }
	value["HH"]=LZ(H);
	value["K"]=lHour+1
	value["KK"]=LZ(lHour+1);
  // assign the AM/PM values
  if (lHour > 11) {
    value["A"]="PM";
  } else {
    value["A"]="AM";
  }
	value["M"]=lMin;
	value["MM"]=LZ(lMin);
	value["S"]=lSec;
	value["SS"]=LZ(lSec);
	// Now build the return value
	// iterate through the format string and pull out the tokens;
  // each token will be a valid format code
  // then add the value for that token to the retVal string
	while (formatItr < format.length) {
    // first grab the character at position == formatItr
		lChar=format.charAt(formatItr);
		lToken="";
		// keep grabbing chars as long as the token character does not change
		while ((format.charAt(formatItr)==lChar) && (formatItr < format.length)) {
			lToken += format.charAt(formatItr++);
		}
		// If the token we have in lToken is one of our format values, add it to the retVal string
    if (value[lToken] != null) {
      retVal = retVal + value[lToken];
    } else {
      // its not a format value, so just add it to the string.. usually these are the slashes in dates, commas, etc.
      retVal=retVal + lToken;
    }
	}
	return retVal;
}

// ---------------------------------------------- function LZ(x)   -----------------------------------
// format a number with a leading 0 if below 10...
// Code from:
//   http://www.mattkruse.com/javascript/date/source.html
//   Author: Matt Kruse <matt@mattkruse.com>
//
function LZ(x) {return(x<0||x>9?"":"0")+x}

